View Issue Details

IDProjectCategoryView StatusLast Update
0002516SymmetricDSBugpublic2016-03-11 19:24
ReporterelongAssigned Toelong 
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
Product Version3.7.0 
Target Version3.7.30Fixed in Version3.7.30 
Summary0002516: Extensions are static to server but should be local to engine
DescriptionExtensions configured in the sym_extensions table are dynamically compiled and kept in a singleton cache. When multiple engines are deployed within the same server instance, each extension gets a single object that is used by all engines. Each engine should get its own set of extension objects because an extension may need to work with the engine and its database.
Steps To Reproducepublic class Checker implements IHeartbeatListener, ISymmetricEngineAware {

    ISymmetricEngine engine;
        
    public void heartbeat(Node me) {
        String myid = engine.getSqlTemplate().queryForString("select node_id from sym_node_identity");
        System.out.println("Object " + this + " I heartbeat " + me.getNodeId() + " - " + myid);
    }

    @Override
    public long getTimeBetweenHeartbeatsInSeconds() {
        return 5;
    }

    @Override
    public void setSymmetricEngine(ISymmetricEngine engine) {
        this.engine = engine;
    }

}
TagsNo tags attached.

Activities

There are no notes attached to this issue.

Related Changesets

SymmetricDS: 3.7 1fda8583

2016-03-03 16:49:27

admin

Details Diff
0002516: Extensions are static to server but should be local to engine
0002516
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/load/JavaDatabaseWriterFilter.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/route/JavaDataRouter.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/IExtensionService.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/impl/ExtensionService.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/impl/TransformService.java Diff File
mod - symmetric-io/src/test/java/org/jumpmind/symmetric/io/data/writer/TransformWriterTest.java Diff File
mod - symmetric-util/src/main/java/org/jumpmind/util/SimpleClassCompiler.java Diff File

Issue History

Date Modified Username Field Change
2016-03-03 16:26 elong New Issue
2016-03-03 16:26 elong Status new => assigned
2016-03-03 16:26 elong Assigned To => elong
2016-03-03 17:00 admin Changeset attached => SymmetricDS 3.7 1fda8583
2016-03-04 11:21 elong Status assigned => resolved
2016-03-04 11:21 elong Fixed in Version => 3.7.30
2016-03-04 11:21 elong Resolution open => fixed
2016-03-11 19:24 elong Status resolved => closed